---
title: DOM Inspector internals
slug: Tools/Add-ons/DOM_Inspector/Internals
tags:
  - Code
  - Tools
  - internals
  - organisation
  - source
---
<div>{{ToolsSidebar}}</div><p>There are three main facets to DOM Inspector. The one you are likely to be most familiar with is its <code>inspector.xul</code>-based primary UI. This is the two-pane inspector that appears when Ctrl+Shift+I (or Cmd+Shift+I) is pressed from one of the applications for which DOM Inspector has explicit support (i.e., menuitems placed via overlay).</p>

<p><img alt="DOM Inspector primary UI inspecting browser.xul" class="default internal" src="/@api/deki/files/4686/=domi-edit-search-onclick.png"></p>

<p>Besides the DOM Inspector's primary UI, there are a couple other top-level inspectors which differ slightly (the object inspector and DOM Inspector sidebar used in SeaMonkey). Initially, we will begin by focusing on <code>inspector.xul</code> and its entry point, and then expand our focus later to explain how these other inspectors differ.</p>

<h2 id="DOM_Inspector_from_a_high-level_perspective">DOM Inspector from a high-level perspective</h2>

<p>The DOM inspector primary UI consists of some toolbars and a <strong>panelset</strong>. The panelset contains two <strong>panels</strong>. One panel reacts to changes to the inspected document, and the other panel reacts to changes to the selection in the first panel. These are the document panel and the object panel, respectively. (Internally, a panel may be loosely referred to as a "pane", but a panelset is always referred to as a "panelset".)</p>

<p>A panel's purpose is to manage available <strong>viewers</strong>. At the top of each panel is a toolbar which contains a menu button allowing you to choose which viewer to display from the <strong>viewer list</strong>, a label displaying the name of the currently active viewer, and another menu button allowing you to issue viewer-specific commands.</p>

<p>Viewers are dynamically loaded; when the panel is made to switch from one viewer to another, the old viewer is destroyed, and the new viewer is loaded in its place. In this way, the panelset and panels function like a frameset and frames. This comparison turns out to be quite apt, since each panel actually contains an anonymous <code><a href="/en/XUL/browser" title="en/XUL/browser">browser</a></code>, and individual viewers exist in separate documents loaded in the browser. This separation allows for viewers to be self-contained, with a viewer's XUL defined in its own document and loaded in its own scope, without fear of collisions in the XUL, CSS, or JS. Another convenient consequence of this is that if you use a properly set up <a href="/en/Setting_up_an_extension_development_environment" title="en/Setting up an extension development environment">development profile</a>, then for the most part, the effects of development changes can be seen by switching away from the current viewer and back.</p>

<p>Knowing this about the way viewers are written, we should now be at a place where we can look at the way the DOM Inspector source is organized.</p>

<h2 id="Source_code_organization">Source code organization</h2>

<p>The contents of the top-level directory for the DOM Inspector repository should look like</p>

<ul>
 <li>base/
  <ul>
   <li>js/
    <ul>
     <li>inspector-cmdline.js</li>
     <li>Makefile.in</li>
    </ul>
   </li>
  </ul>
 </li>
 <li>build/
  <ul>
   <li>install.js</li>
   <li>Makefile.in</li>
  </ul>
 </li>
 <li>resources/
  <ul>
   <li>content/
    <ul>
     <li><var>…</var></li>
    </ul>
   </li>
   <li>locale/
    <ul>
     <li><var>…</var></li>
    </ul>
   </li>
   <li>skin/
    <ul>
     <li><var>…</var></li>
    </ul>
   </li>
   <li>Makefile.in</li>
  </ul>
 </li>
 <li>install.rdf</li>
 <li>jar.mn</li>
 <li>Makefile.in</li>
 <li>makefiles.sh</li>
</ul>

<p>Almost all the interesting stuff is in resources/content/. Its contents should resemble the following:</p>

<ul>
 <li>extensions/
  <ul>
   <li>…</li>
  </ul>
 </li>
 <li>jsutil/
  <ul>
   <li>…</li>
  </ul>
 </li>
 <li>prefs/
  <ul>
   <li>…</li>
  </ul>
 </li>
 <li>res/
  <ul>
   <li>…</li>
  </ul>
 </li>
 <li>tests/
  <ul>
   <li>…</li>
  </ul>
 </li>
 <li>viewers/
  <ul>
   <li>…</li>
  </ul>
 </li>
 <li>browserOverlay.xul</li>
 <li>commandOverlay.xul</li>
 <li>editingOverlay.xul</li>
 <li>Flasher.js</li>
 <li>hooks.js</li>
 <li>inspector.css</li>
 <li>inspector.js</li>
 <li>inspectorOverlay.xul</li>
 <li>inspector.xml</li>
 <li>inspector.xul</li>
 <li>keysetOverlay.xul</li>
 <li>object.js</li>
 <li>object.xul</li>
 <li>popupOverlay.xul</li>
 <li>sidebar.js</li>
 <li>sidebar.xul</li>
 <li>statusbarOverlay.xul</li>
 <li>tasksOverlay-cz.xul</li>
 <li>tasksOverlay-ff.xul</li>
 <li>tasksOverlay-mobile.xul</li>
 <li>tasksOverlay-sb.xul</li>
 <li>tasksOverlay-tb.xul</li>
 <li>tasksOverlay.xul</li>
 <li>toolboxOverlay.xul</li>
 <li>utils.js</li>
 <li>venkmanOverlay.xul</li>
 <li>ViewerRegistry.js</li>
</ul>

<h3 id="Overlays">Overlays</h3>

<p>You will notice that there are a lot of overlays. Some overlays can be described as host-integration overlays, and others as shared structure overlays.</p>

<h4 id="Host-integration_overlays">Host-integration overlays</h4>

<p>DOM Inspector is a general-purpose extension, suitable for use with any Mozilla toolkit host application. In order for DOM Inspector to be useful with its host application, though, there should be a way to launch DOM Inspector within it, e.g., by a menu item and an optional keyboard shortcut such as Ctrl+Shift+I (or Cmd+Shift+I). Either the host applications must provide these themselves (usually bundling DOM Inspector with the application, too), or DOM Inspector must explicitly support them by providing its own menu items and keyboard shortcuts with host-integration overlays.</p>

<p>DOM Inspector explicitly supports several Mozilla project applications by providing its own host-integration overlays. These overlays are:</p>

<ul>
 <li>browserOverlay.xul</li>
 <li>tasksOverlay-cz.xul</li>
 <li>tasksOverlay-ff.xul</li>
 <li>tasksOverlay-mobile.xul</li>
 <li>tasksOverlay-sb.xul</li>
 <li>tasksOverlay-tb.xul</li>
 <li>tasksOverlay.xul</li>
 <li>venkmanOverlay.xul</li>
 <li>prefs/prefsOverlay.xul</li>
</ul>

<p>Further examination of the <a href="en/chrome.manifest">chrome manifest</a> will reveal that DOM Inspector also uses conditional overlays on its primary window:</p>

<pre><code>overlay chrome://inspector/content/inspector.xul chrome://communicator/content/utilityOverlay.xul application={92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}
overlay chrome://inspector/content/inspector.xul chrome://communicator/content/tasksOverlay.xul application={92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}</code>
</pre>

<pre><code>overlay chrome://inspector/content/inspector.xul chrome://browser/content/baseMenuOverlay.xul application={ec8030f7-c20a-464f-9b0e-13a3a9e97384}</code>
</pre>

<p>These host-provided overlays allow DOM Inspector to adopt a look and feel similar to its host application. (Above, SeaMonkey and Firefox, respectively.)</p>

<p>There are several overlays from the resources/contents/ directory that do not fall into the category of host-integration overlays. That's because DOM Inspector also uses shared overlays to build up its own UI.</p>

<h4 id="Shared_structure_overlays">Shared structure overlays</h4>

<p>Taking a look at the contents of inspector.xul, DOM Inspector's primary UI, will reveal that it contains almost no visible elements. As of this writing, there's a <code><a href="/en/XUL/toolbox" title="en/XUL/toolbox">toolbox</a></code> containing an empty <code><a href="/en/XUL/menubar" title="en/XUL/menubar">menubar</a></code> and an empty <code><a href="/en/XUL/toolbar" title="en/XUL/toolbar">toolbar</a></code>, as well as an empty <code><a href="/en/XUL/vbox" title="en/XUL/vbox">vbox</a></code>:</p>

<pre><code>  &lt;toolbox id="tbxInsToolbox"&gt;
    &lt;menubar id="mbrInspectorMain"/&gt;
    &lt;toolbar id="tbInspectorPrimary"/&gt;
  &lt;/toolbox&gt;

  &lt;vbox id="bxInspectorMain" flex="1"/&gt;</code>
</pre>

<p>There are no menus, toolbar items, et cetera defined here. Even most of the elements that aren't visible, such as <code><a href="/en/XUL/keyset" title="en/XUL/keyset">key</a></code>- and <code><a href="/en/XUL/commandset" title="en/XUL/commandset">commandset</a></code>s, are not defined in inspector.xul. These are pulled in from a series of overlays, so that the XUL defining DOM Inspector's UI can be organized into discrete units. inspector.xul itself is only a skeleton describing the basic structure and layout of the primary DOM Inspector window, leaving most of its contents to be added by the overlays.</p>

<p>Using modular overlays also allows for common XUL to be shared across the various documents that make up the DOM Inspector's UI, although not all overlays are shared by multiple consumers. Single-consumer overlays exist solely for organization.</p>

<p>In some cases overlays are overlaid by other overlays. If we imagine a tree structure obtained by connecting overlays as children to the files they overlay,   while ignoring any overlays used for host integration, we can visualize the host-agnostic overlay tree for a given file. Here's the expanded, host-agnostic overlay tree for inspector.xul:</p>

<ul>
 <li><a class="external" rel="freelink">chrome://inspector/content/inspector.xul</a>

  <ul>
   <li><a class="external" rel="freelink">chrome://inspector/content/inspectorOverlay.xul</a></li>
   <li><a class="external" rel="freelink">chrome://inspector/content/toolboxOverlay.xul</a></li>
   <li><a class="external" rel="freelink">chrome://inspector/content/popupOverlay.xul</a>
    <ul>
     <li><a class="external" rel="freelink">chrome://inspector/content/editingOverlay.xul</a></li>
     <li><a class="external" rel="freelink">chrome://inspector/content/viewers/d...pupOverlay.xul</a></li>
     <li><a class="external" rel="freelink">chrome://inspector/content/viewers/s...pupOverlay.xul</a></li>
    </ul>
   </li>
   <li><a class="external" rel="freelink">chrome://inspector/content/commandOverlay.xul</a>
    <ul>
     <li><a class="external" rel="freelink">chrome://inspector/content/viewers/d...andOverlay.xul</a></li>
    </ul>
   </li>
   <li><a class="external" rel="freelink">chrome://inspector/content/keysetOverlay.xul</a>
    <ul>
     <li><a class="external" rel="freelink">chrome://inspector/content/viewers/d...setOverlay.xul</a></li>
    </ul>
   </li>
   <li><a class="external" rel="freelink">chrome://inspector/content/statusbarOverlay.xul</a></li>
   <li><a class="external" rel="freelink">chrome://global/content/globalOverlay.xul</a></li>
  </ul>
 </li>
</ul>

<p>(Note that the overlays from the viewer subdirectories—viewers/dom and viewers/styleRules—are loaded as a result of <a href="/en/Chrome_Registration#overlay" title="/en/chrome.manifest#overlay"><code>overlay</code> directives</a> in DOM Inspector's chrome manifest, rather than being explicitly imported using a <code>xul-overlay</code> processing instruction in the overlaid file.)</p>

<dl>
 <dt>inspectorOverlay.xul</dt>
 <dd>
 <p>This imports the scripts the top-level inspector needs, including dependencies. Additionally, it defines the content in the main body of the DOM Inspector window, namely, the panelset, document and object viewer panels, and the document browser pane. (The browser pane is not a viewer panel in the sense that document and object panels are, i.e., the sorts of panels as defined above in relation to the panelset; "pane" is used here with regard to the browser pane in a loose sense to describe the generic UI fixture.)</p>
 </dd>
 <dt>toolboxOverlay.xul</dt>
 <dd>
 <p>This overlay fills in the inspector toolbox, including toolbar buttons and the location bar and its "Inspect" button. toolboxOverlay.xul also defines the structure of the menubar, without defining the contents of any of the menus themselves.</p>
 </dd>
 <dt>popupOverlay.xul</dt>
 <dd>
 <p>This overlay defines most of the static structure of the menus in the menubar, with some exceptions. For obvious reasons, the contents of dynamic menus are not defined here. The dynamic menus include the Inspect menus' ("Inspect Content Document" and "Inspect Chrome Document") popups from the File menu, and the "Document Viewer" and "Object Viewer" menus from the View menu. The preference menuitems in the View menu that affect only the DOM Nodes viewer ("Blink Selected Element", et cetera) are added by that viewer's popup overlay (resources/content/viewers/dom/popupOverlay.xul). The same is true for the Find menuitems and the "Select Element By Click" menuitem in the Edit menu, since no other viewers besides the DOM Nodes viewer support these features.</p>

 <p>The other Edit menu items are also used in several viewers' context menus. For that reason, only those menuitems' ids are referenced here, and the complete definitions are imported from editingOverlay.xul. Viewers which include one or more of these menuitems in their context menus follow the same practice.</p>

 <p>The tooltip used for the Inspect menus—the one used to show a document's title (if any) and its URI for a given menuitem—is also defined here.</p>
 </dd>
 <dt>commandOverlay.xul</dt>
 <dd>The popupOverlay.xul-provided menuitems that delegate to external <code><a href="/en/XUL/command" title="en/XUL/command">command</a></code> elements have their commands defined here.</dd>
 <dt>keysetOverlay.xul</dt>
 <dd>Some popupOverlay.xul-provided menuitems have their <code><a href="/en/XUL/key" title="en/XUL/key">key</a></code>s defined here. As of this writing, all of the keys that correspond to Edit menu items live in editingOverlay for no good reason.</dd>
 <dt>statusbarOverlay.xul</dt>
 <dd>This defines the contents of the DOM Inspector's status bar. DOM Inspector doesn't have a status bar, so this is entirely useless.</dd>
</dl>
